function VueMulti() { }

VueMulti.prototype=new Vue();

VueMulti.prototype.init=function (app,name) {
	// Appel de la fonction parente
	Vue.prototype.init.bind(this)(app,name);
	// Enregistrement des commandes de la vue
	this.commande('retourner');
	// Acquisition d'une référence aux éléments d'affichage
	this.score=document.querySelector('div.vue.choisie ul.infos '
		+'li:first-child span').firstChild;
	this.score.textContent=0;
	this.essais=document.querySelector('div.vue.choisie ul.infos '
		+'li:nth-child(2) span').firstChild;
	this.essais.textContent=0;
	this.vies=document.querySelector('div.vue.choisie ul.infos '
		+'li:nth-child(3) span').firstChild;
	this.vies.textContent=2;
	// on récupère la liste des cartes
	this.cartes=document.querySelectorAll(
		'div.vue.choisie div.cartes p');
	// ajout de l'écouteur de messages websockets
	this.app.connexionWS.onmessage=this.message.bind(this);
}

VueMulti.prototype.retourner=function (event, params) {
	// si l'interface n'est pas gelée
	// en attente d'une réponse du serveur
	if(!this.interfaceGelée) {
		var carte=this.cartes[parseInt(params['carte'],10)-1];
		// on vérifie que la carte soit bien côté dos
		if(carte.classList.contains('face')
			||this.carte2)
			return false;
		this.app.connexionWS.send(JSON.stringify({'type':'retourne','carte':params['carte']}));
		this.interfaceGelée=true;
		console.log('hi'+params['carte']);
	}
}

VueMulti.prototype.message=function (event) {
	var réponse=JSON.parse(event.data);
	if((!réponse.type))
		throw Error('Message innatendu de la part du serveur.');
	// réception de la réponse due au retournement d'une carte
	if('carte'==réponse.type) {
		var carte=this.cartes[parseInt(réponse.carte,10)-1];
		if(carte.classList.contains('trouvee')
			||carte.classList.contains('choisie')
			||this.carte2)
			return false;
		// retournement de la carte
		this.afficherCarte(carte,réponse.joueur,réponse.numero,true);
		// si les cartes sont différentes
		if(this.carte1) {
			this.app.sons.jouer('pasbien');
			// on garde une ref à la deuxième carte
			this.carte2=carte;
			// on programme le masquage des cartes
			setTimeout(function() {
				// si elles sont trouvées, alors ne pas cacher
				if(this.carte1.classList.contains('choisie'))
					this.cacherCarte(this.carte1);
				if(this.carte2.classList.contains('choisie'))
					this.cacherCarte(this.carte2);
				this.carte1=null;
				this.carte2=null;
				this.interfaceGelée=false;
				}.bind(this),1000);
		} else {
			// on a une réponse, on dégèle l'interface
			this.interfaceGelée=false;
			// on garde une ref à la première carte
			this.carte1=carte;
		}
	} else if('paire'==réponse.type) {
		// on récupère les cartes
		var carte1=this.cartes[parseInt(réponse.carte1,10)-1],
			carte2=this.cartes[parseInt(réponse.carte2,10)-1];
		// on affiche les deux cartes
		this.afficherCarte(carte1,réponse.joueur,réponse.numero,false);
		this.afficherCarte(carte2,réponse.joueur,réponse.numero,false);
		// si l'une des cartes était retournée par l'utilisateur
		if(this.carte1&&(this.carte1==carte1||this.carte1==carte2)) {
			this.carte1=null;
			this.interfaceGelée=false;
		}
		// si c'est une paire du joueur
		if(réponse.joueur==this.app.utilisateur.id) {
			this.app.sons.jouer('alerte2');
			this.vies.parentNode.classList.add('warn2');
			// on diminue le nombre de vies
			this.vies.textContent=parseInt(this.vies.textContent,10)-1;
			// si le joueur n'a plus de vies, on le bloque
			if(0===parseInt(this.vies.textContent,10))
				{
				this.interfaceGelée=true;
				this.app.sons.jouer('perdu');
				this.app.afficherMessage('Perdu !');
				}
		}
		// si c'est le joueur qui l'a trouvé
		else if(réponse.gagnant==this.app.utilisateur.id) {
			this.app.sons.jouer('bien');
			carte1.classList.add('trouvee');
			carte2.classList.add('trouvee');
			// on incrémente le score
			this.score.textContent=parseInt(this.vies.textContent,10)+1;
			this.interfaceGelée=false;
		} else {
			this.app.sons.jouer('alerte1');
		}
	} else if('victoire'==réponse.type) {
		if(réponse.gagnant==this.app.utilisateur.id) {
			this.app.afficherMessage('Bravo !',2000,function(){
				this.app.montrerVue('Salon');
			}.bind(this));
			this.app.sons.jouer('applaudissements');
		}
		else
			this.app.afficherMessage('Terminé !',2000,function(){
				this.app.montrerVue('Salon');
			}.bind(this));
	}
}

// retournement d'une carte côté dos
VueMulti.prototype.cacherCarte=function (carte) {
	carte.classList.remove('face');
	carte.classList.remove('choisie');
}

// retournement d'une carte côté face
VueMulti.prototype.afficherCarte=function (carte,idJoueur,numéro,choisie) {
	carte.classList.add('face');
	if(choisie)
		carte.classList.add('choisie');
	else
		carte.classList.remove('choisie');
	this.app.salon.joueurs.forEach(function(joueur) {
		if(idJoueur==joueur.id) {
			carte.firstChild.firstChild.style.backgroundImage='url('
				+joueur['image'+numéro]+')';
			carte.firstChild.firstChild.style.backgroundSize='contain';
		}
	});
}

VueMulti.prototype.raz=function (app) {
	this.carte1=null;
	for(var i=this.cartes.length-1; i>=0; i--) {
		this.cartes[i].classList.remove('choisie');
		this.cartes[i].classList.remove('trouvee');
		this.cartes[i].classList.remove('face');
	}
}

VueMulti.prototype.uninit=function (app) {
	this.raz();
	Vue.prototype.uninit.bind(this)();
}
