// AMD + global
(function(root,define){ define([], function () {

	// Vues génériques
	function Vue() {}

	// Initialisation de la vue
	Vue.prototype.init=function (app,nom) {
		// on garde une référence à l'application
		this.app=app;
		// on sauve le nom de la vue
		this.nom=nom;
		// récupération de l'élément HTML correspondant
		this.contenu=document.getElementById(nom);
		if(!this.contenu)
			throw Error('La vue "'+nom+'" n\'a pas été trouvée.');
		// on affiche la vue
		this.contenu.classList.add('choisie');
	}

	// Enregistrement de commande simplifié
	Vue.prototype.commande=function (nom,méthode) {
		// si pas de méthode spécifiée :
		// on utilise le nom de la commande
		méthode=méthode||nom;
		if(!this[méthode])
			throw Error('Impossible de trouver le méthode "'+méthode+'".');
		// on enregistre la méthode dans le gestionnaire
		this.app.gestionnaire.suscribe(this.nom+'/'+nom,
			this[méthode].bind(this));
	}

	// Désarmorçage de la vue
	Vue.prototype.uninit=function () {
		// Suppression des commandes
		this.app.gestionnaire.unsuscribe(this.nom);
		this.contenu.classList.remove('choisie');
	}

	return Vue;

})})(this,typeof define === 'function' && define.amd ? define : function (name, deps, factory) {
	this[name.substring(name.lastIndexOf('/')+1)]=factory.apply(this, deps.map(function(dep){
		return this[dep.substring(dep.lastIndexOf('/')+1)];
	}));
});
