// Vues génériques
function Vue() {}

// Initialisation de la vue
Vue.prototype.init=function (app,nom) {
	// on garde une référence à l'application
	this.app=app;
	// on sauve le nom de la vue
	this.nom=nom;
	// récupération de l'élément HTML correspondant
	this.contenu=document.getElementById(nom);
	if(!this.contenu)
		throw Error('La vue "'+nom+'" n\'a pas été trouvée.');
	// on affiche la vue
	this.contenu.classList.add('choisie');
}

// Enregistrement de commande simplifié
Vue.prototype.commande=function (nom,méthode) {
	// si pas de méthode spécifiée :
	// on utilise le nom de la commande
	méthode=méthode||nom;
	if(!this[méthode])
		throw Error('Impossible de trouver le méthode "'+méthode+'".');
	// on enregistre la méthode dans le gestionnaire
	this.app.gestionnaire.ajouterCommande(this.nom+'/'+nom,
		this[méthode].bind(this));
}

// Désarmorçage de la vue
Vue.prototype.uninit=function () {
	// Suppression des commandes
	this.app.gestionnaire.retirerCommande(this.nom);
	this.contenu.classList.remove('choisie');
}
