function VueSalon()	{ }

VueSalon.prototype=new Vue();

VueSalon.prototype.init=function (app,name) {
	// Appel de la fonction parente
	Vue.prototype.init.bind(this)(app,name);
	// référencement des zone dynamiques
	this.h1=document.querySelector('div.vue.choisie h1');
	this.h1.firstChild.textContent=this.app.salon.nom+' ';
	this.bouton=document.querySelector('div.vue.choisie a[disabled="disabled"]');
	this.majJoueurs();
	this.chat=document.querySelector('div.vue.choisie p.chat');
	this.champs=document.querySelector('div.vue.choisie input[type="text"]');
	// Enregistrement des commandes de la vue
	this.commande('quitter');
	this.commande('envoi');
	this.commande('jouer');
	this.commande('notification');
	// vérification de la possibilité d'activer les notifications
	this.boutonNotification=document.querySelector('div.vue.choisie p.menu a:nth-child(3)');
	if('webkitNotifications' in window
		&&window.webkitNotifications.checkPermission()===1) {
			this.boutonNotification.style.display='';
		} else {
			this.boutonNotification.style.display='none';
		}
	// ajout de l'écouteur de messages websockets
	this.app.connexionWS.onmessage=this.message.bind(this);
}

VueSalon.prototype.quitter=function (event, params) {
	this.app.connexionWS.send(JSON.stringify({'type':'salon','salon':null}));
	this.app.salon=null;
}

VueSalon.prototype.envoi=function (event, params) {
	this.app.connexionWS.send(JSON.stringify({'type':'chat','message':this.champs.value}));
	this.champs.value='';
}

VueSalon.prototype.jouer=function (event) {
	this.app.connexionWS.send(JSON.stringify({'type':'debut'}));
}

VueSalon.prototype.message=function (event) {
	var réponse=JSON.parse(event.data);
	if((!réponse.type))
		throw Error('Message innatendu de la part du serveur.');
	if('debut'==réponse.type) {
		this.app.sons.jouer('gagne');
		this.app.montrerVue('Multi');
	} else if('salon'==réponse.type) {
		this.app.montrerVue('Salons');
	} else if('arrivee'==réponse.type) {
		this.app.salon.joueurs.push(réponse.joueur);
		this.ligneChat('',réponse.joueur.nom+' a rejoint le salon.');
		this.majJoueurs();
	} else if('depart'==réponse.type) {
		this.app.salon.joueurs.some(function(joueur,i) {
			if(réponse.joueur==joueur.id) {
				this.app.salon.joueurs.splice(i,1);
				this.ligneChat('',joueur.nom+' a quitté le salon.');
				return true;
			}
		}.bind(this));
		this.majJoueurs();
	} else if('chat'==réponse.type) {
		this.ligneChat(réponse.joueur,réponse.message);
	}
}

VueSalon.prototype.majJoueurs=function () {
	this.h1.lastChild.firstChild.textContent=this.app.salon.joueurs.length+' /3';
	if(this.app.salon.joueurs.length==3) {
		this.bouton.setAttribute('disabled','');
		// on tente d'afficher une notification
		if('webkitNotifications' in window
			&&window.webkitNotifications.checkPermission()===0) {
			var notification = window.webkitNotifications.createNotification(
				this.app.utilisateur.image1, 'Prêt à jouer',
				'La partie peut commencer, trois joueurs sont présents !');
			notification.show();
		}
	} else {
		this.bouton.setAttribute('disabled','disabled');
	}
}

VueSalon.prototype.ligneChat=function (joueur,message) {
		if(this.chat.firstChild)
			this.chat.appendChild(document.createElement('br'));
		if(joueur) {
			this.chat.appendChild(document.createElement('strong'));
			this.chat.lastChild.appendChild(document.createTextNode(joueur+' : '));
			this.chat.appendChild(document.createTextNode(message));
		} else {
			this.chat.appendChild(document.createTextNode(message));
		}
	this.chat.scrollTop=this.chat.scrollHeight;
}

// demande de permission pour les notifications
VueSalon.prototype.notification=function (event) {
	// demande
	window.webkitNotifications.requestPermission();
	// suppression du bouton
	this.boutonNotification.style.display='none';
}

VueSalon.prototype.vider=function (event) {
	while(this.chat.firstChild)
		this.chat.removeChild(this.chat.firstChild);
}

VueSalon.prototype.uninit=function (app) {
	this.vider();
	this.bouton.setAttribute('disabled','disabled');
	Vue.prototype.uninit.bind(this)();
}
