function VueSalons() { }

VueSalons.prototype=new Vue();

VueSalons.prototype.init=function (app,name) {
	// Appel de la fonction parente
	Vue.prototype.init.bind(this)(app,name);
	// Enregistrement des commandes de la vue
	this.commande('rejoindre');
	this.commande('rafraichir');
	// Acquisition d'une référence aux éléments d'affichage
	this.tableau=document.querySelector('div.vue.choisie table tbody');
	this.modeleLigne=this.tableau.firstChild;
	this.tableau.removeChild(this.modeleLigne);
	// ajout de l'écouteur de messages websockets
	this.app.connexionWS.onmessage=this.message.bind(this);
	// envoi d'une demande de listing des salons
	this.rafraichir();
}

VueSalons.prototype.rejoindre=function (event, params) {
	this.app.connexionWS.send(JSON.stringify({'type':'salon','salon':params['salon']}));
}

VueSalons.prototype.rafraichir=function (event, params) {
	this.app.connexionWS.send(JSON.stringify({'type':'salons','page':1}));
}

VueSalons.prototype.message=function (event) {
	var réponse=JSON.parse(event.data);
	if((!réponse.type))
		throw Error('Message innatendu de la part du serveur.');
	if('salons'==réponse.type&&réponse.liste) {
		// on vide la liste des salons
		this.vider();
		// on affiche la liste des salons
		var nouvelleLigne;
		for(var i=0, j=réponse.liste.length; i<j; i++) {
			nouvelleLigne=this.modeleLigne.cloneNode(true);
			// Mise en place du lien
			nouvelleLigne.firstChild.firstChild.firstChild.textContent=réponse.liste[i].nom;
			nouvelleLigne.firstChild.firstChild.setAttribute('href',
				this.modeleLigne.firstChild.firstChild.getAttribute('href')+réponse.liste[i].id);
			// ajout du nombre de joueurs
			nouvelleLigne.childNodes[1].firstChild.textContent=réponse.liste[i].joueurs+'/3';
			// ajout du type de salon
			nouvelleLigne.childNodes[2].firstChild.textContent=réponse.liste[i].mode;
			// insertion de la ligne
			this.tableau.appendChild(nouvelleLigne);
		}
	} else if('salon'==réponse.type) {
		// si le salon est tjrs ok, on charge la vue
		if(réponse.salon) {
			// on garde une référence au salon
			this.app.salon=réponse.salon;
			// on ajoute le joueur au salon
			this.app.salon.joueurs.push(this.app.utilisateur);
			// on affiche la vue salon
			this.app.montrerVue('Salon');
		}
		// sinon on, actualise
		else
			this.rafraichir();
	}
}
	
VueSalons.prototype.vider=function (event) {
	while(this.tableau.firstChild)
		this.tableau.removeChild(this.tableau.firstChild);
}

VueSalons.prototype.uninit=function (app) {
	this.vider();
	this.tableau.appendChild(this.modeleLigne);
	Vue.prototype.uninit.bind(this)();
}
