// Objet application
function Application(racine) {
	// Recherche d'une nouvelle version
	if(window.applicationCache) {
		window.applicationCache.addEventListener('updateready',function()
			{
			console.log('ready');
			// on ne demande la mise à jour
			// que si le joueur n'est pas entrain de jouer
			if((!window['VueMono'])||this.vue!=window['VueMono'])
				this.montrerVue('Maj');
		}.bind(this));
	}
	// stockage de l'élément HTML racine
	this.racine=racine;
	// création d'un gestionnaire de commande
	this.gestionnaire=new GestionnaireCommandes(racine);
	// création d'un gestionnaire de sons et ajout des sons
	this.sons=new GestionnaireSons('sounds',
		// joue le son de fond une fois chargé
		function() { this.sons.jouer('mountainman'); }.bind(this));
	this.sons.enregistrer('mountainman',['mid','mp3'],Infinity,0.2);
	this.sons.enregistrer('carte1',['ogg']);
	this.sons.enregistrer('carte2',['ogg']);
	this.sons.enregistrer('bien',['ogg','mp3']);
	this.sons.enregistrer('pasbien',['ogg']);
	this.sons.enregistrer('applaudissements',['ogg']);
	this.sons.enregistrer('alerte1',['ogg']);
	this.sons.enregistrer('alerte2',['ogg']);
	this.sons.enregistrer('perdu',['ogg']);
	this.sons.enregistrer('gagne',['ogg']);
	// Récupération de la préférence son coupé
	try {
		if(window.localStorage&&window.localStorage.sonCoupé)
			this.sons.muter(!!window.localStorage.sonCoupé);
	} catch(e) {}
	// Enregistrement de la commande de changement de vue
	this.gestionnaire.ajouterCommande('changerVue',
		this.changerVue.bind(this));
	// stockage de l'élément pour afficher des messages
	this.message=document.querySelector('div.app div.message p');
	// on affiche la première vue
	this.montrerVue('Accueil');
}
// Gestion des messages
Application.prototype.afficherMessage=function (texte,durée,callback) {
	if(this.messageTimeout)
		clearTimeout(this.messageTimeout);
	this.messageTimeout=setTimeout(this.cacherMessage.bind(this),durée||1500);
	this.messageCallback=callback;
	this.message.firstChild.textContent=texte;
	this.message.parentNode.classList.add('affiche');
}
Application.prototype.cacherMessage=function () {
	this.message.parentNode.classList.remove('affiche');
	this.messageTimeout=null;
	this.messageCallback();
	this.messageCallback=null;
}
// Gestion des vues
Application.prototype.changerVue=function (event,params) {
	this.montrerVue(params.vue);
}
Application.prototype.montrerVue=function (name) {
	// on désamorce la vue précédente
	if(this.vueAffichée)
		this.vueAffichée.uninit();
	// on lance la vue suivante
	// soit la vue a un constructeur dédié
	// soit on utilise le constructeur générique Vue
	if(undefined===window['Vue'+name]) {
		var requete=new XMLHttpRequest();
		requete.open('GET','javascript/Vue'+name+'.js',false);
		requete.send();
		if(200!==requete.status)
			window['Vue'+name]=null;
		else
			eval.bind(window)(requete.responseText);
	}
	this.vueAffichée=new (window['Vue'+name]||window['Vue'])();
	this.vueAffichée.init(this,name);
}
// On lance l'application
var app=new Application(document.querySelector('div.app'));
