'use strict';

// Objet application
function Application(racine) {
	// stockage de l'élément HTML racine
	this.racine=racine;
	// création d'un gestionnaire de commande
	this.gestionnaire=new GestionnaireCommandes(racine);
	// Enregistrement de la commande de changement de vue
	this.gestionnaire.ajouterCommande('changerVue',
		this.changerVue.bind(this));
	// stockage de l'élément pour afficher des messages
	this.message=document.querySelector('div.app div.message p');
	// on affiche la première vue
	this.montrerVue('Accueil');
}
// Gestion des messages
Application.prototype.afficherMessage=function (texte,durée,callback) {
	if(this.messageTimeout)
		clearTimeout(this.messageTimeout);
	this.messageTimeout=setTimeout(this.cacherMessage.bind(this),durée||1500);
	this.messageCallback=callback;
	this.message.firstChild.textContent=texte;
	this.message.parentNode.classList.add('affiche');
}
Application.prototype.cacherMessage=function () {
	this.message.parentNode.classList.remove('affiche');
	this.messageTimeout=null;
	this.messageCallback();
	this.messageCallback=null;
}
// Gestion des vues
Application.prototype.changerVue=function (event,params) {
	this.montrerVue(params.vue);
}
Application.prototype.montrerVue=function (name) {
	// on désamorce la vue précédente
	if(this.vueAffichée)
		this.vueAffichée.uninit();
	// on lance la vue suivante
	// soit la vue a un constructeur dédié
	// soit on utilise le constructeur générique Vue
	this.vueAffichée=new (window['Vue'+name]||window['Vue'])();
	this.vueAffichée.init(this,name);
}
// On lance l'application
new Application(document.querySelector('div.app'));
