// On crée un objet de gestion des commandes
function GestionnaireCommandes(racine) {
	// On garde une référence à l'élément racine
	// du gestionnaire de commandes
	this.racine=racine;
	// On ajoute les écouteurs d'évènements
	// le clic pour les boutons
	this.racine.addEventListener('click',
		this.captureBouton.bind(this),true);
	// l'envoi pour les formulaires
	this.racine.addEventListener('submit',
		this.captureFormulaire.bind(this),true);
	this.commandes={};
}
GestionnaireCommandes.prototype.captureBouton=function(event) {
	var element=event.target,
		commande='';
	// on remonte les parent de l'élément pour
	// trouver un lien ou un bouton de soumission
	while(element!==this.racine
		&&element.nodeName!=='A'
		&&(element.nodeName!='INPUT'
				||(!element.hasAttribute('type'))
				||element.getAttribute('type')!='submit'
				||!element.hasAttribute('formaction'))) {
		element=element.parentNode;
	}
	// Si l'élément est un lien activable la commande
	// est dans href
	if('A'===element.nodeName&&element.hasAttribute('href'))
		commande=element.getAttribute('href');
	// Si l'élément est un bouton de formulaire la commande
	// est dans formaction
	if('INPUT'===element.nodeName
			&&element.hasAttribute('type')
			&&element.getAttribute('type')=='submit'
			&&element.hasAttribute('formaction'))
		commande=element.getAttribute('formaction');
	// Si la commande existe on stoppe la propagation
	// et on annule l'évènement
	this.exécuterCommande(event,commande)
		&&(event.stopPropagation()
		||event.preventDefault());
};
GestionnaireCommandes.prototype.captureFormulaire=function(event) {
	var element=event.target,
		commande='';
	// on remonte les parent de l'élément pour
	// trouver un formulaire
	while(element!==this.racine
		&&'FORM'!==element.nodeName)
		{
		element=element.parentNode;
		}
	// Si l'élément est un formulaire et propose une commande
	if('FORM'===element.nodeName&&element.hasAttribute('action'))
		commande=element.getAttribute('action');
	// Si la commande existe on stoppe la propagation
	// et on annule l'évènement
	this.exécuterCommande(event,commande)
		&&(event.stopPropagation()
		||event.preventDefault());
};
GestionnaireCommandes.prototype.exécuterCommande=function (event,commande) {
	// Si la commande ne commence pas par un hash
	// on ne fait rien
	if(0!==commande.indexOf('app:'))
		return false;
	// Sinon, on réduit la commande
	commande=commande.substr(4);
	// et on découpe en morceaux
	var morceaux=commande.split('?');
	// le premier morceau est l'index de la commande
	var fonction=this.commandes;
	var nœuds=morceaux[0].split('/');
	for(var i=0, j=nœuds.length; i<j; i++) {
		if(!fonction[nœuds[i]])
			throw Error('La commande "'+commande+'" n\'a pas été trouvée.');
		fonction=fonction[nœuds[i]];
	}
	// on prépare les arguments, les morceaux restant
	var args=[];
	if(morceaux[1]) {
		morceaux=morceaux[1].split('&');
		for(var i=0, j=morceaux.length; i<j; i++) {
			var parties=morceaux[i].split('=');
			if(undefined!==parties[0]&&undefined!==parties[1])
				args[parties[0]]=decodeURIComponent(parties[1]);
		}
	}
	// On exécute la fonction et on retourne
	// false si tout est ok, true si la commande retourne
	// true
	return !!!fonction(event,args);
};
GestionnaireCommandes.prototype.ajouterCommande=function(nom,fonction) {
	var nœuds=nom.split('/');
	var commande=this.commandes;
	for(var i=0, j=nœuds.length-1; i<j; i++) {
		if((!commande[nœuds[i]])||!(commande[nœuds[i]] instanceof Object))
			commande[nœuds[i]]={};
		commande=commande[nœuds[i]];
	}
	commande[nœuds[i]]=fonction;
};
GestionnaireCommandes.prototype.retirerCommande=function(nom) {
	var nœuds=nom.split('/');
	var commande=this.commandes;
	for(var i=0, j=nœuds.length-1; i<j; i++) {
		commande=commande[nœuds[i]]={};
	}
	commande[nœuds[i]]=null;
};
