// Vue pour jeu en solo
function VueMono() { }
// Hérite de Vue
VueMono.prototype=new Vue();
// Initialisation
VueMono.prototype.init=function (app,name) {
	// Appel de la fonction parente
	Vue.prototype.init.bind(this)(app,name);
	// Enregistrement des commandes de la vue
	this.commande('retourner');
	this.commande('recommencer');
	// Acquisition d'une référence aux éléments d'affichage
	this.niveau=document.querySelector('div.vue.choisie ul.infos '
		+'li:first-child span').firstChild;
	this.temps=document.querySelector('div.vue.choisie ul.infos '
		+'li:nth-child(2) span').firstChild;
	this.essais=document.querySelector('div.vue.choisie ul.infos '
		+'li:nth-child(3) span').firstChild;
	// Mise en route
	this.recommencer();
}
// Recommence le jeu au début
VueMono.prototype.recommencer=function () {
	// Mise à zéro du niveau courant
	this.niveau.textContent=1;
	// distribution des cartes
	this.distribuer();
}
// Commence un niveau
VueMono.prototype.distribuer=function () {
	// Remise à 0 des essais
	this.essais.textContent=0;
	// Remise à 0 des paires trouvées
	this.paireTrouvées=0;
	// Récupération des cartes
	var pileCartes=Array.prototype.slice.call(
		document.querySelectorAll('div.vue.choisie div.cartes p'),0);
	// Distribution des cartes
	this.cartes=[];
	var couleurs = ['FF0000','0000FF','00FF00','00FFFF','FF00FF','FFFF00'];
	for(var i=(pileCartes.length/2)-1; i>=0; i--) {
		var carte1=pileCartes.splice(Math.floor(Math.random()*pileCartes.length),1)[0];
		var carte2=pileCartes.splice(Math.floor(Math.random()*pileCartes.length),1)[0];
		carte1.setAttribute('href','app:Mono/retourner?carte='+i);
		carte2.setAttribute('href','app:Mono/retourner?carte='+(i+1));
		carte1.typeCarte=carte2.typeCarte=couleurs.pop();
		this.cartes.push(carte2.jumelle=carte1,carte1.jumelle=carte2);
	}
	// Remise à zéro des classes
	this.raz();
	// Mise en route du timer
	this.tempsMax=new Date(Date.now()+5000+(120000/parseInt(this.niveau.textContent)));
	if(!this.timeoutTemps)
		this.majTemps();
}
// mise à jour du compte à rebours
VueMono.prototype.majTemps=function () {
	// Différence entre tempsMax et moment actuel en secondes
	var tempsRestant=(this.tempsMax.getTime()-Date.now())/1000;
	// Si le temps restant est négatif, on le remet à 0
	if(0>=tempsRestant)
		tempsRestant=0;
	// Affichage dans l'élément adequat
	this.temps.textContent=Math.floor(tempsRestant/60)
		+'\''+(Math.floor(tempsRestant%60)<10?'0':'')+Math.floor(tempsRestant%60);
	// Programmation du prochain affichage
	if(tempsRestant>0) {
		this.timeoutTemps=setTimeout(arguments.callee.bind(this), 1000);
	// Plus de temps, le joueur a perdu
	} else {
		this.timeoutTemps=null;
		this.app.afficherMessage('Perdu !',3000,this.recommencer.bind(this));
	}
}
// Commande pour retourner une carte
VueMono.prototype.retourner=function (event, params) {
	// on vérifie qu'on est pas entrain d'afficher un résultat
	if(this.timeoutResultat)
		return false;
	// récupération de la carte cliquée
	var carte=document.querySelector(
		'div.cartes p:nth-child('+params['carte']+')');
	// on vérifie qu'elle n'est pas déjà trouvée ou sélectionnée
	if(carte.classList.contains('trouvee')
		||carte.classList.contains('choisie'))
		return false;
	// on la sélectionne
	carte.classList.add('face');
	carte.classList.add('choisie');
	// ajout de la couleur associée à la carte
	carte.firstChild.style.backgroundColor='#'+carte.typeCarte;
	// Si aucune carte choisie on garde une référence à celle-ci
	if(!this.carte1) {
		this.carte1=carte;
	// sinon, on vérifie si elle sont jumelles
	} else {
		this.carte2=carte;
		// si elles sont jumelle on appelle la méthode gagner
		// sinon on appelle la méthode perdre
		this.timeoutResultat=setTimeout(
			this[(this.carte1.jumelle==this.carte2?'gagner':'perdre')].bind(this),
			(this.carte1.jumelle==this.carte2?100:700));
	}
}
// action si la paire est pas bonne
VueMono.prototype.perdre=function () {
	this.timeoutResultat=null;
	this.carte1.classList.toggle('face');
	this.carte1.classList.toggle('choisie');
	this.carte2.classList.toggle('face');
	this.carte2.classList.toggle('choisie');
	this.carte1=null;
	this.carte2=null;
	// on ajoute un essai infructueux
	this.essais.textContent=parseInt(this.essais.textContent,10)+1;
}
// action si la paire est bonne
VueMono.prototype.gagner=function () {
	// on passe les deux carte en état trouvé
	this.timeoutResultat=null;
	this.carte1.classList.toggle('choisie');
	this.carte1.classList.toggle('trouvee');
	this.carte2.classList.toggle('choisie');
	this.carte2.classList.toggle('trouvee');
	// on réinitialise les cartes sélectionnées
	this.carte1=null;
	this.carte2=null;
	// on ajoute la paire trouvéee
	this.paireTrouvées++;
	// si toutes les paires sont trouvée
	if(this.paireTrouvées==this.cartes.length/2) {
		this.niveau.textContent=parseInt(this.niveau.textContent,10)+1;
		clearTimeout(this.timeoutTemps);
		this.timeoutTemps=null;
		// on félicite le joueur et on programme une nouvelle distribution
		this.app.afficherMessage('Bravo !',1500,this.distribuer.bind(this));
	}
}
// on remet la vue dans son état initial
VueMono.prototype.raz=function () {
	this.carte1=null;
	this.carte2=null;
	if(this.timeoutResultat) {
		clearTimeout(this.timeoutResultat);
		this.timeoutResultat=null;
	}
	for(var i=this.cartes.length-1; i>=0; i--) {
		this.cartes[i].classList.remove('choisie');
		this.cartes[i].classList.remove('trouvee');
		this.cartes[i].classList.remove('face');
	}
}
// désinitialisation de la vue
VueMono.prototype.uninit=function (app) {
	// suppression du compte à rebours
	clearTimeout(this.timeoutTemps);
	// remise à zéro de la vue
	this.raz();
	// appel de la focntion parente
	Vue.prototype.uninit.bind(this)();
}
