// AMD + global
(function(root,define){ define(['Vue'], function (Vue) {

	function VueProfil() { }

	VueProfil.prototype=new Vue();

	VueProfil.prototype.init=function (app,name) {
		Vue.prototype.init.bind(this)(app,name);
		// création de l'utilisateur
		if(!this.app.utilisateur)
			this.app.utilisateur={'nom':'','sexe':-1};
		// Enregistrement des commandes
		this.commande('envoi');
		this.commande('changement');
		this.commande('photo');
		// Récupération du formulaire
		var form=document.querySelector('div.vue.choisie form');
		// Création de la tâche de fond
		this.tâcheFond=new Worker('/javascript/Compare.js');
		this.photosSeRessemblent=true;
		this.tâcheFond.onmessage=function(event) {
			if('ok'==event.data) {
				form.elements.photo2.setCustomValidity('');
			} else if('pasok'==event.data) {
				form.elements.photo2.setCustomValidity('Les images se ressemblent trop, merci d\'en choisir une autre.');
			}
		}.bind(this);
		// ajout de l'image par défaut
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		// Ajout de l'évènement de dépôt
		form.addEventListener('dragenter', function(e) {
			e.stopPropagation(); e.preventDefault(); }, false);
		form.addEventListener('dragover', function(e) {
			e.stopPropagation(); e.preventDefault(); }, false);
		form.addEventListener('drop', this.dépôt.bind(this), false);
		// création de l'image par défaut
		this.imageDéfaut(images[0],form.elements.utilisateur.value,1);
		this.imageDéfaut(images[1],form.elements.utilisateur.value,2);
		// Tentative d'accès à la caméra
		(navigator.getUserMedia||navigator.webkitGetUserMedia
			||navigator.mozGetUserMedia||navigator.msGetUserMedia
			||(function(){})).call(navigator,{'video':true},
			this.initialiserVidéo.bind(this),
			function(erreur) {
				console.log(erreur);
			});
	};

	VueProfil.prototype.changement=function (event,params,form) {
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		// on dessine l'image par défaut si il n'y a pas de photo
		if(event.target==form.elements.photo||(event.target==form.elements.utilisateur
			&&!(form.elements.photo.files&&form.elements.photo.files.length))) {
			if(form.elements.photo.files&&form.elements.photo.files.length)
				this.imagePerso(form.elements.photo.files[0],images[0],1);
			else
				this.imageDéfaut(images[0],form.elements.utilisateur.value,1);
			form.elements.photo2.setCustomValidity('Patientez pendant l\'analyse de votre image.');
		}
		if(event.target==form.elements.photo2||(event.target==form.elements.utilisateur
			&&!(form.elements.photo2.files&&form.elements.photo2.files.length))) {
			if(form.elements.photo2.files&&form.elements.photo2.files.length)
				this.imagePerso(form.elements.photo2.files[0],images[1],2);
			else
				this.imageDéfaut(images[1],form.elements.utilisateur.value,2);
			form.elements.photo2.setCustomValidity('Patientez pendant l\'analyse de votre image.');
		}
	};

	VueProfil.prototype.imagePerso=function (fichier,image,n) {
		// on récupère le contenu du fichier sous forme de dataUri
		var reader = new FileReader();
		reader.readAsDataURL(fichier);
		reader.onload = function(event) {
			// on charge la dataUri dans une image
			var img=document.createElement('img');
			img.src = event.target.result;
			// quand elle est chargée
			img.onload=function() {
				// on crée notre élément canvas
				var canvas=document.createElement('canvas');
				// on choisit les dimensions max de l'image
				canvas.width=90;
				canvas.height=90;
				// on récupère le contexte 2d
				var contexte=canvas.getContext('2d');
				// on dessine l'image dans le canvas
				// en prenant le plus grand carré possible
				// et en le centrant
				contexte.drawImage(img,
					(img.width>img.height?(img.width-img.height)/2:0),
					(img.width>img.height?0:(img.height-img.width)/2),
					(img.width>img.height?img.height:img.width),
					(img.width>img.height?img.height:img.width),
					0, 0,90,90);
				// on récupère le contenu du canvas sous forme de dataURI
				// pour le réinjecter dans l'image
				image.src = canvas.toDataURL();
				// puis on l'envoi à la tâche de fond pour traitement
				this.tâcheFond.postMessage(JSON.stringify({'image':n,'données':
					Array.prototype.slice.call(contexte.getImageData(0,0,90,90).data,0)}));
			}.bind(this);
		}.bind(this);
	};

	VueProfil.prototype.imageDéfaut=function (image,utilisateur,n) {
		// on crée notre élément canvas
		var canvas=document.createElement('canvas');
		// on choisit les dimensions de l'image
		canvas.width=90;
		canvas.height=90;
		// on récupère le contexte 2d
		var contexte=canvas.getContext('2d');
		// on dessine l'image dans le canvas
		// choix d'une couleur de remplissage aléatoire
		contexte.fillStyle = 'rgba('+Math.floor(Math.random()*200)
			+','+Math.floor(Math.random()*200)
			+','+Math.floor(Math.random()*200)+',0.4)';
		// dessin cercle 0
		contexte.beginPath();
		contexte.arc(Math.floor(Math.random()*80)+5,
			Math.floor(Math.random()*80)+5, 5, 0, Math.PI*2, true); 
		contexte.closePath();
		contexte.fill();
		// dessin cercle 1
		contexte.beginPath();
		contexte.arc(Math.floor(Math.random()*70)+10,
			Math.floor(Math.random()*70)+10, 10, 0, Math.PI*2, true); 
		contexte.closePath();
		contexte.fill();
		// dessin cercle 2
		contexte.beginPath();
		contexte.arc(Math.floor(Math.random()*60)+15,
			Math.floor(Math.random()*60)+15, 15, 0, Math.PI*2, true); 
		contexte.closePath();
		contexte.fill();
		// dessin cercle 3
		contexte.beginPath();
		contexte.arc(Math.floor(Math.random()*50)+20,
				Math.floor(Math.random()*50)+20, 20, 0, Math.PI*2, true); 
		contexte.closePath();
		contexte.fill();
		// on ajout le nom de l'utilisateur
		contexte.fillStyle = '#000';
		contexte.textAlign = 'center';
		contexte.textBaseline='middle';
		contexte.font = "20pt Arial";
		contexte.fillText(utilisateur, 45, (n==1?22:67),90);
		// on récupère le contenu du canvas sous forme de dataURI
		image.src = canvas.toDataURL();
		// puis on l'envoi à la tâche de fond pour traitement
		this.tâcheFond.postMessage(JSON.stringify({'image':n,'données':
			Array.prototype.slice.call(contexte.getImageData(0,0,90,90).data,0)}));
	};

	// fonction de réception de dépôt de fichier
	VueProfil.prototype.dépôt=function (event) {
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		if(event.target==images[0]||event.target==images[1]) {
			if(event.dataTransfer.files&&event.dataTransfer.files.length
				&&event.dataTransfer.files[0].type.indexOf('image/')===0) {
					this.imagePerso(event.dataTransfer.files[0],event.target);
					var form=document.querySelector('div.vue.choisie form');
					form.elements.photo2.setCustomValidity('Patientez pendant l\'analyse de votre image.');
				}
		}
		// on annule l'action par défaut
		event.stopPropagation();
		event.preventDefault();
	};

	// On initialise l'interface utilisateur pour permettre
	// l'affichage de la webcam et la prise de photos
	VueProfil.prototype.initialiserVidéo=function (fluxVidéo) {
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		var video = document.createElement('video');
		video.setAttribute('class','profil');
		if (navigator.mozGetUserMedia)
			video.mozSrcObject = fluxVidéo;
		else
			video.src = (window.URL || window.webkitURL)
				.createObjectURL(fluxVidéo);
		var a=document.createElement('a');
		a.setAttribute('title','Prendre une photo');
		var a2=a.cloneNode();
		a.setAttribute('href','app:Profil/photo?image=1');
		a.appendChild(video);
		video.play();
		a2.setAttribute('href','app:Profil/photo?image=2');
		a2.appendChild(video.cloneNode());
		a2.firstChild.play();
		images[0].parentNode.insertBefore(a,images[0]);
		images[1].parentNode.insertBefore(a2,images[1]);
	};

	VueProfil.prototype.photo=function (event, params) {
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		var videos=document.querySelectorAll('div.vue.choisie video.profil');
		// on crée notre élément canvas
		var canvas=document.createElement('canvas');
		// on choisit les dimensions de l'image
		canvas.width=90;
		canvas.height=90;
		// on récupère le contexte 2d
		var contexte=canvas.getContext('2d');
		// on dessine l'image actuelle
		// du flux vidéo dans le canvas
		var vid=videos[params.image-1];
		contexte.drawImage(vid,
			(vid.videoWidth>vid.videoHeight?(vid.videoWidth-vid.videoHeight)/2:0),
			(vid.videoWidth>vid.videoHeight?0:(vid.videoHeight-vid.videoWidth)/2),
			(vid.videoWidth>vid.videoHeight?vid.videoHeight:vid.videoWidth),
			(vid.videoWidth>vid.videoHeight?vid.videoHeight:vid.videoWidth),
			0, 0,90,90);
		// on récupère le contenu du canvas sous forme de dataURI
		// pour le réinjecter dans l'image
		images[params.image-1].src = canvas.toDataURL();
	};

	VueProfil.prototype.envoi=function (event, params) {
		var images=document.querySelectorAll('div.vue.choisie img.profil');
		// on récupère les infos sur l'utilisateur
		this.app.utilisateur={'nom':event.target[0].value,
			'sexe':(event.target[4].checked?1:event.target[5].checked?0:-1),
			'image1':images[0].src,'image2':images[1].src};
		// on se connecte au serveur web socket
		if(!this.app.connexionWS)
			this.app.connexion();
		else
			this.app.identification();
		// on récupérère les messages
		this.app.connexionWS.onmessage=this.connecté.bind(this);
	};

	VueProfil.prototype.connecté=function (event) {
		var réponse=JSON.parse(event.data);
		if((!réponse.type)||'connexion'!=réponse.type||!réponse.sessid)
			throw Error('Message innatendu de la part du serveur.');
		// on stocke l'id du joueur
		this.app.utilisateur.sessid=réponse.sessid;
		this.app.utilisateur.id=réponse.id;
		// on affiche la vue salons
		this.app.montrerVue('Salons');
	};

	VueProfil.prototype.uninit=function (app) {
		var videos=document.querySelectorAll('div.vue.choisie video.profil');
		if(videos&&videos.length) {
			for(var i=videos.length-1; i>=0; i--)
				videos[i].parentNode.parentNode.removeChild(videos[i].parentNode);
		}
		Vue.prototype.uninit.bind(this)();
	};

	return VueProfil;

});})(this,typeof define === 'function' && define.amd ? define : function (name, deps, factory) {
	this[name.substring(name.lastIndexOf('/')+1)]=factory.apply(this, deps.map(function(dep){
		return this[dep.substring(dep.lastIndexOf('/')+1)];
	}));
});
