// AMD + global
(function(root,define){ define(['Vue'], function (Vue) {

	function VueSalons() { }

	VueSalons.prototype=new Vue();

	VueSalons.prototype.init=function (app,name) {
		// Appel de la fonction parente
		Vue.prototype.init.bind(this)(app,name);
		// Enregistrement des commandes de la vue
		this.commande('rejoindre');
		this.commande('rafraichir');
		// Acquisition d'une référence aux éléments d'affichage
		this.tableau=document.querySelector('div.vue.choisie table tbody');
		this.modeleLigne=this.tableau.firstChild;
		this.tableau.removeChild(this.modeleLigne);
		// ajout de l'écouteur de messages websockets
		this.app.connexionWS.onmessage=this.message.bind(this);
		// envoi d'une demande de listing des salons
		this.rafraichir();
	};

	VueSalons.prototype.rejoindre=function (event, params) {
		this.app.connexionWS.send(JSON.stringify({'type':'salon','salon':params.salon}));
	};

	VueSalons.prototype.rafraichir=function (event, params) {
		// on vide la liste des salons
		this.vider();
		// on crée la requête
		var requête=new XMLHttpRequest();
		var indexDernièreLigne=0;
		requête.open('GET','/salons/liste.csv',true);
		requête.onprogress=requête.onload=function(event){
			// récupération du dernier retour à la ligne
			var nouvelIndex=requête.responseText.lastIndexOf('\n');
			// extraction des lignes
			if(nouvelIndex!==-1&&indexDernièreLigne<nouvelIndex) {
				var contenu=requête.responseText.substring(indexDernièreLigne,nouvelIndex+1);
				// parsing du CSV
				var valeur='';
				var champs=[];
				for(var i=0, j=contenu.length; i<j; i++) {
					// caractère d'échappement
					if('\\'==contenu[i]) {
						valeur+=contenu[i+1];
						i++;
					// caractères de fin de champs
					} else if(','==contenu[i]||'\r'==contenu[i]||'\n'==contenu[i]||i==j-1) {
						champs.push(valeur);
						valeur='';
						// caractère de fin de ligne
						if('\r'==contenu[i]||'\n'==contenu[i]||i==j-1) {
							// affichage de la ligne
							this.afficherLigne(champs);
							// raz des champs
							champs=[];
						if('\r'==contenu[i])
							i++;
						}
					} else {
						if(contenu[i]!='"')
							valeur+=''+contenu[i];
					}
				}
				// sauvegarde du nouvel index
				indexDernièreLigne=nouvelIndex+1;
			}
		}.bind(this);
		requête.send();
	};

	VueSalons.prototype.afficherLigne=function (champs) {
			var nouvelleLigne=this.modeleLigne.cloneNode(true);
			// Mise en place du lien
			nouvelleLigne.firstChild.firstChild.firstChild.textContent=champs[1];
			nouvelleLigne.firstChild.firstChild.setAttribute('href',
				this.modeleLigne.firstChild.firstChild.getAttribute('href')+champs[0]);
			// ajout du nombre de joueurs
			nouvelleLigne.childNodes[1].firstChild.textContent=champs[3]+'/3';
			// ajout du type de salon
			nouvelleLigne.childNodes[2].firstChild.textContent=champs[2];
			// insertion de la ligne
			this.tableau.appendChild(nouvelleLigne);
	};

	VueSalons.prototype.message=function (event) {
		var réponse=JSON.parse(event.data);
		if((!réponse.type))
			throw Error('Message innatendu de la part du serveur.');
		if('salon'==réponse.type) {
			// si le salon est tjrs ok, on charge la vue
			if(réponse.salon) {
				// on garde une référence au salon
				this.app.salon=réponse.salon;
				// on ajoute le joueur au salon
				this.app.salon.joueurs.push(this.app.utilisateur);
				// on affiche la vue salon
				this.app.montrerVue('Salon');
			}
			// sinon on, actualise
			else
				this.rafraichir();
		}
	};
	
	VueSalons.prototype.vider=function (event) {
		while(this.tableau.firstChild)
			this.tableau.removeChild(this.tableau.firstChild);
	};

	VueSalons.prototype.uninit=function (app) {
		this.vider();
		this.tableau.appendChild(this.modeleLigne);
		Vue.prototype.uninit.bind(this)();
	};

	return VueSalons;

});})(this,typeof define === 'function' && define.amd ? define : function (name, deps, factory) {
	this[name.substring(name.lastIndexOf('/')+1)]=factory.apply(this, deps.map(function(dep){
		return this[dep.substring(dep.lastIndexOf('/')+1)];
	}));
});
