﻿var MailPopup = {

   "afficher": function() {
      // Première ouverture de la popup mail => Création
      if ( $('#mailPopup').size() == 0 ) {
         this.ajouteHTML();
         this.ajouteEvenements();
      }

      // Calcul de la position du coin supérieur gauche 
      // pour que la popup soit centrée horizontalement 
      // et verticalement
      var top  = $(window).scrollTop() + 
         ($(window).height() - $('#mailPopup').height()) /2;
      
      var left = $(window).scrollLeft() + 
         ($(window).width()  - $('#mailPopup').width())  /2;

      // Positionnement et affichage de la popup
      // Focus du premier champ du formulaire
      $('#mailPopup')
         .css('top' , Math.max(0, top))
         .css('left', Math.max(0, left))
         .slideDown('slow')
         .find(':text,textarea')
         .first()
         .focus();
         
      $('#overlay').fadeIn();
   },

   "cacher": function() {
      // Ferme la popup
      // Retire l'overlay une fois que la popup est fermée
      $('#mailPopup').slideUp('slow', function() {
         $('#overlay').fadeOut();
      });
   },
   
   "ajouteHTML": function() {

      var html = [];
      var i    = 0;

      html[i++] = '<div id="mailPopup">';
      html[i++] = '<form>';
      
      // Titre de la popup
      html[i++] =    '<div id="header">';
      html[i++] =       'Formulaire de contact';
      html[i++] =       '<div id="cmdCancel">X</div>';
      html[i++] =    '</div>';

      // Contenu de la popup
      html[i++] =    '<div id="body">';

      html[i++] =       '<div>';
      html[i++] =          '<label for="mail">Votre email *</label>';
      html[i++] =          '<input type="text" id="mail" class="obligatoire email" />';
      html[i++] =       '</div>';

      html[i++] =       '<div>';
      html[i++] =          '<label for="nom">Votre nom</label>';
      html[i++] =          '<input type="text" id="nom" />';
      html[i++] =       '</div>';

      html[i++] =       '<div>';
      html[i++] =          '<label for="sujet">Sujet *</label>';
      html[i++] =          '<input type="text" id="sujet" data-minLength="5" />';
      html[i++] =       '</div>';

      html[i++] =       '<div>';
      html[i++] =          '<label for="msg">Message *</label>';
      html[i++] =          '<textarea id="msg" data-minLength="10"></textarea>';
      html[i++] =       '</div>';

      html[i++] =       '<div>';
      html[i++] =          '<input type="submit" id="cmdSend" value="Envoyer" />';
      html[i++] =       '</div>';
      
      html[i++] =    '</div>';
      
      html[i++] = '</form>';
      html[i++] = '</div>';
      
      $('body').append( html.join('') );
      $('body').append('<div id="overlay"></div>');
   },
   
   "ajouteEvenements": function() {

      // L'utilisateur peut déplacer la popup
      // en cliquant sur la section "titre"
      $('#mailPopup').draggable({"handle": "#header"});

      // Utilisation de $.proxy() pour établir le contexte
      // d'exécution de la fonction cacher()
      $('#cmdCancel').click($.proxy(this.cacher, this));
      
      // Soumission du formulaire
      $('#mailPopup').children('form').submit(
         {"maPopup": this}, 
         function(event) {
         
            if ($(this).trigger('validerFormulaire').
               data('isFormValid')) {
               
               event.data.maPopup.envoyerMail();
               
            } else {
               // Affichage message d'erreur
               //event.data.maPopup.afficherMsgSoumission(
               //   'Formulaire non complet', 'submitError');
               alert('Formulaire non complet');
            }

            // Evite la redirection du formulaire
            return false;
         }
      );
   },
   
   "envoyerMail": function() {
       alert('To be continued...');
   },
   
   "afficherMsgSoumission": function(msg, css) {
   
      $('#cmdSend')
      .after('<div class="' + css + '">' + msg + '</div>')
      .next()
      .fadeOut(5000, function() {
         $(this).remove();
      });
   }
};
