﻿// Validation des champs textes
$(document).on('validerChampTexte', ':text,textarea', 
function() {

   var errMessages = [];
   var val         = $.trim( $(this).val() );
   
   // Le champ est obligatoire
   if ( $(this).hasClass('obligatoire') && val == '') {
      errMessages.push('Champ obligatoire');
   }
   
   // Expression régulière pour les champs "email"
   var reg = '^([a-z0-9._-]+@[a-z0-9._-]+\\.[a-z]{2,4})?$';
   var regexEmail = new RegExp(reg, 'i');
   
   // Champ email: on teste le format aaa@bbb.ccc
   if ($(this).hasClass('email') && !regexEmail.test(val)) {
      errMessages.push('Format invalide');
   }
   
   // Longueur minimum du champ
   var minLength  = $(this).attr('data-minLength') == null ?
      0 : parseInt($(this).attr('data-minLength'));
   
   // On teste la longueur de la valeur
   if ( minLength > 0 && val.length < minLength ) {
      errMessages.push(minLength + ' caractères minimum!');
   }   

   // La valeur du champ est valide s'il n'y a 
   // pas de message d'erreur
   var isValid = errMessages.length == 0;
   
   // Le message à afficher à côté du champ
   var msg = '<div class="valid">:)</div>';
   if ( !isValid ) {
      msg = '<div class="error">' + 
         errMessages.join('<br />') + '</div>';
   }
   
   // Retire le message précédent (s'il existe)
   if ($(this).next().is('div.error,div.valid')) {
      $(this).next().remove();
   }
   
   // Affiche nouveau message
   $(this).after(msg);
   
   // Sauvegarde la validité du champ
   $(this).data('isChampValid', isValid);
});

// Validation des formulaires
$(document).on('validerFormulaire', 'form', function() {

   var isValid = true;

   // this = le formulaire
   $(this)
      .find(':text,textarea')
      .each(function() {
         // this = le champ texte et non le formulaire
      
         $(this).trigger('validerChampTexte');

         if ($(this).data('isChampValid') == false) {
            isValid = false;
         }
         
         // quicker method:
         // isValid = $(this).trigger('validerChampTexte')
         //    .data('isChampValid');
         // return isValid;
      })
   .end()
   .data('isFormValid', isValid);
});

$(document).on('reset', 'form', function() {
   $(this).find('div.error,div.valid').remove();
   $(this).get(0).reset();
   
});

// On teste la validité des champa au fur et à 
// mesure que l'utilisateur les complète
$(document).on('keyup change', ':text,textarea', function() {
   $(this).trigger('validerChampTexte');
});